%{
/* $Header: /home/pm3fb/fbtimings2pm3/fbt2pm3-lex.l,v 1.5 2001/06/14 15:15:24 dolbeau Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include "fbtimings2pm3.h"
#include "fbt2pm3-par.h"
%}

%%

mode                  return MODE;

geometry              return GEOMETRY;

timings               return TIMINGS;

\"[^\n]+\"      { yylval.chaine = malloc(1 + yyleng); (void)strncpy(yylval.chaine, yytext, yyleng); yylval.chaine[yyleng] = 0; return MODE_NAME; }

endmode               return ENDMODE;

[0-9]+                yylval.entier = atoi(yytext); return ENTIER;

"#"[^\n]*"\n"         /* eat up comment */

[ \t\n]+              /* eat up whitespace */

hsync                 return HSYNC;

vsync                 return VSYNC;

high                  yylval.sk = sync_high; return SKIND;

low                   yylval.sk = sync_low; return SKIND;

laced                 return LACED;

true                  yylval.entier = 1; return BOOL;

false                 yylval.entier = 0; return BOOL;

accel                 return ACCEL;

rgba                  return RGBA;

[0-9]+"/"[0-9]+         return FRAC;

,                     return COMMA;

.                     fprintf(stderr, "%s", yytext);

%%
