%{
/* $Header: /home/pm3fb/fbtimings2pm3/fbt2pm3-par.y,v 1.5 2001/06/14 15:15:24 dolbeau Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include "fbtimings2pm3.h"
%}

%union {
  sync_kind_t sk;
  char* chaine;
  unsigned long entier;
}
 

%token MODE
%token ENDMODE
%token <chaine> MODE_NAME
%token GEOMETRY
%token <entier> ENTIER
%token TIMINGS
%token HSYNC
%token VSYNC
%token <sk> SKIND
%token LACED
%token <entier> BOOL
%token ACCEL
%token RGBA
%token FRAC
%token COMMA

%%

input:    /* empty */
          | fullmode input

fullmode: MODE MODE_NAME
          GEOMETRY ENTIER ENTIER ENTIER ENTIER ENTIER
          TIMINGS ENTIER ENTIER ENTIER ENTIER ENTIER ENTIER ENTIER
          interlace
          sync
          accel
          rgba
          ENDMODE
          { char video[256];
   	    printf("/* Generated mode : %s */\n", $2);
	    sprintf(video, "PM3VideoControl_ENABLE%s%s%s",
		   ($<entier>18 & HSYNC_HIGH) ? "|PM3VideoControl_HSYNC_ACTIVE_HIGH" :
                                                "|PM3VideoControl_HSYNC_ACTIVE_LOW",
		   ($<entier>18 & VSYNC_HIGH) ? "|PM3VideoControl_VSYNC_ACTIVE_HIGH" :
		    "|PM3VideoControl_VSYNC_ACTIVE_LOW",
		    ($8 == 8) ? "|PM3VideoControl_PIXELSIZE_8BIT" :
                    ($8 == 16) ? "|PM3VideoControl_PIXELSIZE_16BIT" :
                    ($8 == 32) ? "|PM3VideoControl_PIXELSIZE_32BIT" : ""
		   );
	    printf("%s  {%s, {%d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %s}}, %s\n",
		   $<entier>17 ? "/* INTERLACED NOT SUPPORTED\n" : "",
		   $2,
		   (1000000000UL / $10), $4, $5,
		   $12, ($12 + $15), ($12 + $15 + $11), ($4 + $12 + $15 + $11),
		   $14, ($14 + $16), ($14 + $16 + $13), ($5 + $14 + $16 + $13),
		   $4, 0, $8,
		   video,
		   $<entier>17 ? "\n   INTERLACED NOT SUPPORTED */" : ""
		   );
	    /* accel and rgba ignored */
	  }

sync:     /* empty */ { $<entier>$ = 0; }
          | l_sync sync { $<entier>$ = $<entier>2 | $<entier>1; }

l_sync:    HSYNC SKIND { switch($2) {
                             case sync_high: $<entier>$ = HSYNC_HIGH; break;
                             case sync_low: $<entier>$ = HSYNC_LOW; break;
                             default: $<entier>$ = 0; break; }}
          | VSYNC SKIND  { switch($2) {
                             case sync_high: $<entier>$ = VSYNC_HIGH; break;
                             case sync_low: $<entier>$ = VSYNC_LOW; break;
                             default: $<entier>$ = 0; break; }}

interlace:  /* empty */ { $<entier>$ = 0; }
            | LACED BOOL { $<entier>$ = $2; }

accel: /* empty */ { $<entier>$ = 0; }
       | ACCEL BOOL { $<entier>$ = $2; }

rgba: /* empty */ { }
| RGBA fraclist {}


fraclist: FRAC {}
| fraclist COMMA FRAC {}

%%

int
yywrap()
{
  return(1);
}

yyerror (char *s)
{
  fprintf (stderr, "%s\n", s);
}
